//
//  OpenGL Ex15opengl Widget
//

#ifndef EX15OPENGL_H
#define EX15OPENGL_H

#include <QtOpenGL>
#include <QString>

class Ex15opengl : public QGLWidget
{
Q_OBJECT
private:
   bool    init;      //  Initialized
   int     mode;      //  Display mode
   float   pct;       //  Position
   int     th,ph;     //  Display angles
   bool    mouse;     //  Mouse pressed
   QPoint  pos;       //  Mouse position
   double  dim;       //  Display size
   double  asp;       //  Sceen aspect ratio
   unsigned int day[12],night,cge; //  Textures
   QGLShaderProgram shader;  //  Shaders
   QTimer           timer;   //  Timer for animations
   QElapsedTimer    time;    //  Track elapsed time
public:
   Ex15opengl(QWidget* parent=0);                  //  Constructor
   QSize sizeHint() const {return QSize(400,400);} //  Default size of widget
public slots:
    void setShader(int sel);               //  Slot to set shader
    void setPos(int pct);                  //  Slot to set position
    void reset();                          //  Reset view
signals:
    void angles(QString text);             //  Signal for view angles
    void datim(QString text);              //  Signal for date and time
protected:
    void initializeGL();                   //  Initialize widget
    void resizeGL(int width, int height);  //  Resize widget
    void paintGL();                        //  Draw widget
    void mousePressEvent(QMouseEvent*);    //  Mouse pressed
    void mouseReleaseEvent(QMouseEvent*);  //  Mouse released
    void mouseMoveEvent(QMouseEvent*);     //  Mouse moved
    void wheelEvent(QWheelEvent*);         //  Mouse wheel
private:
   void Fatal(QString message);            //  Error handler
   void Projection();                      //  Update projection
   void Shader(QGLShaderProgram& shader,QString vert,QString frag);  //  Create shader
   unsigned int LoadImage(const QString file);                       //  Load texture
};

#endif
